# Automatic noise parse python program for DMM noise measurement project
# http://xdevs.com/article/dmm_noise/ - Article with details
# &copy; xDevs.com 2015

import csv
import sys
import math
import glob
import os
from math import exp, expm1
from datetime import datetime

with open('output.txt','wb') as o:
    print ("| Multimeter \t| Range\t\t|Int sec|    Counts\t|    Sq.sum\t|  Average\t|    RMS\t\t|    RMS,uV\t|")
    o.write ("| Multimeter \t| Range\t\t|Int sec|    Counts\t|    Sq.sum\t|  Average\t|    RMS\t\t|    RMS,uV\t|\r\n")
    for filename in glob.glob('*.csv'):
        i = open(filename, 'r')
        reader = csv.DictReader(i)
        setname = filename.split("_")
        sum = 0
        sqsum = 0
        cnt = 0
        for row in reader:
            # Input filename format here : Keithley2002_DCVOLT.1_NPLC10.csv 
            # file contents parsed following this format: date,Keithley2002 (taken from filename beginning)
            sum = sum + float(row["vmeas"])
            sqsum = sqsum + pow(float(row["vmeas"]),2)
            cnt = cnt + 1
            avg = sum / cnt
            rms = math.sqrt(sqsum / cnt)
        print ("| %s \t\t| %s \t\t| %s \t|\t%d\t| %.8f\t| %E\t| %E\t|%8.2f\t|" % 
            (setname[0],
             setname[1].split("DCVOLT")[1],
             setname[2].split("NPLC")[1].split(".csv")[0],
             cnt,
             sqsum,
             avg,
             rms,
             rms*1E6  
            )
        )
        i.close()
        o.write ("| %s \t\t| %s \t\t| %s \t|\t%d\t| %.8f\t| %E\t| %E\t|%8.2f\t|\r\n" % 
            (setname[0],
             setname[1].split("DCVOLT")[1],
             setname[2].split("NPLC")[1].split(".csv")[0],
             cnt,
             sqsum,
             avg,
             rms,
             rms*1E6  
            )
        )

